Library ieee;
Use ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

Entity rdx is
Port (	baud_r : in	bit;			--Baud rate Clock
		rxd	   : in	std_logic;		--Input Series Data
		dst	   : out std_logic_vector(7 downto 0) --Output Parallel
	 );
End ;

Architecture rdx_a of rdx is
begin
Process (baud_r)
Variable cnt_rxd : integer range 0 to 7 := 0;	--Number Bit Data
Variable detect	 : integer range 0 to 1 := 0;	--Counter Detect
Variable n 		 : integer range 0 to 15;		--Loop Counter
Variable data	 : std_logic_vector( 7 downto 0 );	--Data Register
Begin
if baud_r'event and baud_r = '0' then
	if n = 9  then				--Check Stop Bit = 1 Bit
		if rxd = '1' then
			dst <= data;
		end if;
		cnt_rxd := 0; detect := 0; n := 0;
	elsif detect = 1 then						
		data(cnt_rxd) := rxd;
		cnt_rxd := cnt_rxd + 1; n := n + 1;
	elsif rxd = '0' and detect = 0 then		--Check Start Bit
		detect := 1; cnt_rxd := 0; n := n + 1;
	else									--Reset All Parameters
		detect := 0; cnt_rxd := 0; n := 0;
	end if;
end if;
end process;
end ;
