Library ieee;
Use ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

Entity Read_Ram is
Port 	(	c_rec	:	in	bit;
			sw_smp	:	in	integer range 0 to 1;
			ptc		:	in	integer range 0 to 255;
			d_ram	:	in	integer range 0 to 255;
			RV		:	out	integer range 0 to 255;
			add_lt	:	in	integer range 0 to 4095;
			lt		:	out	bit;
			e_add	:	out	bit;
			add		:	out	integer range 0 to 4095
		);
End ;

Architecture Read_Ram_a of Read_Ram is
begin
Process (c_rec)
Variable add_v	:	integer range 0 to 4095 := 0;
Variable Rec_M	:	integer range 0 to 1 := 0;
Begin
if ptc = 66 or sw_smp = 1 then
	Rec_M := 1;
	add_v := 0;
	RV <= d_ram;
	lt <= '0';
elsif c_rec = '1' and c_rec'event then
	if add_v >= add_lt then
		Rec_M := 0;
		e_add <= '0';
		lt	<=	'1';
	elsif Rec_M = 1 then
		lt	<=	'0';
		e_add <= '1';
		add_v := add_v + 1;
	end if;
	RV <= d_ram;
	add <= add_v;
end if;
end process;
end ;
