Library ieee;
Use ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

Entity tdx_data is
Port ( baud_r :	in	bit;				--	Baud rate Clock
	   en	  :	in	bit;				--	Enable Transmit Data
	   d_temp :	in	unsigned( 7 downto 0);	--	Input Parallel Data
	   tdx	  :	out	std_logic			--	Output Series Data
	 );
End ;

Architecture tdx_data_a of tdx_data is
begin
Process (baud_r)
Variable cnt : integer range 0 to 15 := 0;
Variable dt	 : integer range 0 to 7 := 0;
Begin
if en = '0' then						--	Reset All Parameters
  dt := 0; cnt := 0; tdx <= '1';
elsif baud_r'event and baud_r = '1' then
  if cnt > 8 then
	tdx <= '1';
  elsif cnt > 0 then					--	Data Bit
	tdx <= d_temp(dt); dt := dt + 1; cnt := cnt + 1;
  else
	tdx <= '0';	cnt := cnt + 1;			--	Srart Bit
  end if;
end if;
end process;
end ;
