Library ieee;
Use ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

Entity Control_Data is
Port ( loop_data : in  bit;
	   en_lp	 : in  bit;
	   temp_real : in  integer range 0 to 255;	--Input Temperature Data
	   en_txd	 : out bit;						--Enable Transmitter
	   data_s	 : out integer range 0 to 255	--Output Temperature Data
		);
End ;

Architecture Control_Data_a of Control_Data is
Begin
Process (loop_data)
Variable pte : integer range 0 to 255 := 0;
Variable datae : integer range 0 to 255;
Variable cnt : integer range 0 to 3 := 0;
Variable data : integer range 0 to 255;
Begin
if loop_data = '1' and loop_data'event then
  if en_lp = '1' then
	if temp_real > 127 then				--Low Data Value 0 - 63
	  pte := 71; datae := temp_real - 126;
	  else								--	High Data Value 64 - 127 
	  pte := 82; datae := temp_real;
	end if;
	if cnt = 0 then
	  en_txd <= '1'; data_s <= pte;	cnt := cnt + 1;	--	Send Protocol
	elsif cnt = 2 then
	  en_txd <= '1'; data_s <= datae ; cnt := cnt + 1; --	Send Data
	elsif cnt = 3 then
	  en_txd <= '0';	
	else
	  en_txd <= '0'; cnt := cnt + 1;		
	end if;
  else
	cnt := 0; en_txd <= '0';
  end if;
end if;
End Process;
End;
