Library ieee;
Use ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

Entity ds1620_read_ptc is
Port 	(	dclk	:	in	bit;
			en		:	in	bit;
			dqi		:	in	std_logic;
			dqo		:	out	bit;
			rst		:	out	bit;
			zdq		:	out	bit;
			temp	:	out	std_logic_vector(8 downto 0)
		);
End ;

Architecture ds1620_read_ptc_a of ds1620_read_ptc is
begin
process (dclk)
Variable rd_ptc	: bit_vector(7 downto 0);
variable n : integer range 0 to 31 := 0;
variable rd : integer range 0 to 7 := 0;
variable di : integer range 0 to 8 := 0;
begin

--	SET READ TEMPERATION


if dclk'event and dclk = '1' then

	if en = '0' then
		zdq <= '0';					--	ENABLE DQ_OUT TO SEND DATA
		rst <= '0';					--	ENABLE DS1620 CHIP
		dqo <= '0';					--	SEND DATA SET WRITE CONFIGURATION FROM REGISTOR TO DS1620
		rd_ptc	:=	"10101010";				--	read temperature	AAh
		n := 0;
		rd := 0;
		di := 14;

	elsif n > 18 then
		zdq <= '0';					--	ENABLE DQ_OUT TO SEND DATA
		rst <= '1';					--	ENABLE DS1620 CHIP
		dqo <= '0';					--	SEND DATA SET WRITE CONFIGURATION FROM REGISTOR TO DS1620
		rd := 0;
		di := 0;

	elsif n > 7 then
		zdq <= '0';
		rst <= '1';		
		di := di + 1;				--	NEXT TO READ DATA
		temp(di) <= dqi;			--	SAVE DATA FROM BIT TO NUMBER
		n := n + 1;					--	NEXT CLOCK

	else
		zdq <= '1';					--	ENABLE DQ_OUT TO SEND DATA
		rst <= '1';					--	ENABLE DS1620 CHIP
		dqo <= rd_ptc(rd);			--	SEND DATA SET WRITE CONFIGURATION FROM REGISTOR TO DS1620
		rd := rd + 1;				--	NEXT SEND WRITE CONFIGUARTION PORTOCOL
		n := n + 1;					--	NEXT CLOCK
	end if;

end if;
end process;
end ;
