Library ieee;
Use ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

Entity ds1620_sequence is
Port 	(	dclk		:	in	bit;
			en_find		:	out bit;
			en_w_ptc	:	out	bit;
			en_st_ptc	:	out	bit;
			en_rd_ptc	:	out	bit
		);
End ;

Architecture ds1620_sequence_a of ds1620_sequence is
begin
process (dclk)
variable n : integer range 0 to 127 := 0;
begin

--	DS1620 TRANSMITSION AND RECEIVETION DATA PROCESS

if dclk'event and dclk = '1' then

	case n is
		when   1 => en_w_ptc <= '1';	en_st_ptc <= '0';	en_rd_ptc <= '0';	en_find <= '0';
		when  21 => en_w_ptc <= '0';	en_st_ptc <= '1';	en_rd_ptc <= '0';	en_find <= '0';
		when  61 => en_w_ptc <= '0';	en_st_ptc <= '0';	en_rd_ptc <= '1';	en_find <= '0';
		when  70 => en_find <= '1';
		when 100 => en_w_ptc <= '0';	en_st_ptc <= '0';	en_rd_ptc <= '0';	en_find <= '0';	n := 0;
		when others =>
	end case;
	n := n + 1;						--	NEXT CLOCK

end if;
end process;
end ;
