Library ieee;
Use ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

Entity ds1620_sq is
Port 	(	dclk		:	in	bit;						--	Input Clock
			en			:	out integer range 0 to 7;		--	Output Enable Function
			en_find		:	out bit							--	Output Control Decode Number
		);
End ;

Architecture ds1620_sq_a of ds1620_sq is
Begin
Process (dclk)
Variable n : integer range 0 to 63 := 0;	--	Loop Counter
Begin

--	DS1620 SEQUENCE CONTROLLER

if dclk'event and dclk = '1' then

	if n >= 1 and n < 20 then				--	WRITE CONFIG SET DS1620 TO TEMPERATURE CONVERSION
		en <= 1; en_find <= '0';

	elsif n >= 21 and n < 35 then			--	START CONVERSION
		en <= 2; en_find <= '0';

	elsif n >= 36 and n < 56 then			--	READ TEMPERATURE FROM DS1620
		en <= 4; en_find <= '0';

	elsif n >= 57 then						--	ENABLE DECODE NUMBER OF TEMPERATURE DATA
		en_find <= '1';

	else									--	RESET FUNCTION
		en <= 0;

	end if;

	n := n + 1;								--	NEXT LOOP COUNTER

end if;
End process;
End ;
