Library ieee;
Use ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

Entity ds1620_start_con is
Port 	(	dclk		:	in	bit;
			en		:	in	bit;
			dqo		:	out	bit;
			rst		:	out	bit;
			zdq		:	out	bit
		);
End ;

Architecture ds1620_start_con_a of ds1620_start_con is
begin
process (dclk)
Variable st_con : bit_vector(7 downto 0);
variable n : integer range 0 to 15 := 0;
variable st : integer range 0 to 7 := 0;
begin

--	SET START CONVERSION

if en = '0' then
	zdq <= '0';					--	ENABLE DQ_OUT TO SEND DATA
	rst <= '0';					--	ENABLE DS1620 CHIP
	dqo <= '0';					--	SEND DATA SET WRITE CONFIGURATION FROM REGISTOR TO DS1620
	st_con	:=	"11101110";		--	start conversion	EEh
	n := 0;
	st := 0;

elsif dclk'event and dclk = '1' then

	if n > 7 then
		zdq <= '0';					--	ENABLE DQ_OUT TO SEND DATA
		rst <= '0';					--	ENABLE DS1620 CHIP
		dqo <= '0';					--	SEND DATA SET WRITE CONFIGURATION FROM REGISTOR TO DS1620
		st := 0;
	else
		zdq <= '1';					--	ENABLE DQ_OUT TO SEND DATA
		rst <= '1';					--	ENABLE DS1620 CHIP
		dqo <= st_con(st);			--	SEND DATA SET WRITE CONFIGURATION FROM REGISTOR TO DS1620
		st := st + 1;					--	NEXT SEND WRITE CONFIGUARTION PORTOCOL
		n := n + 1;						--	NEXT CLOCK
	end if;
end if;
end process;
end ;
