Library ieee;
Use ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

Entity ds1620_write is
Port 	(	dclk		:	in	bit;
			en		:	in	bit;
			dqo		:	out	bit;
			rst		:	out	bit;
			zdq		:	out	bit
		);
End ;

Architecture ds1620_write_a of ds1620_write is
begin
process (dclk)
variable w_con : bit_vector(15 downto 0);
variable n : integer range 0 to 15 := 0;
variable w : integer range 0 to 15 := 0;
begin

--	SET WRITE CONFIGURATION

if en = '0' then
	zdq <= '0';					--	ENABLE DQ_OUT TO SEND DATA
	rst <= '0';					--	ENABLE DS1620 CHIP
	dqo <= '0';					--	SEND DATA SET WRITE CONFIGURATION FROM REGISTOR TO DS1620
	w_con := "0000000000001100";
	n := 0;
	w := 0;

elsif dclk'event and dclk = '1' then

	if n > 11 then
		zdq <= '0';					--	ENABLE DQ_OUT TO SEND DATA
		rst <= '0';					--	ENABLE DS1620 CHIP
		dqo <= '0';					--	SEND DATA SET WRITE CONFIGURATION FROM REGISTOR TO DS1620
		w := 0;
	else
		zdq <= '1';					--	ENABLE DQ_OUT TO SEND DATA
		rst <= '1';					--	ENABLE DS1620 CHIP
		dqo <= w_con(w);			--	SEND DATA SET WRITE CONFIGURATION FROM REGISTOR TO DS1620
		w := w + 1;					--	NEXT SEND WRITE CONFIGUARTION PORTOCOL
		n := n + 1;						--	NEXT CLOCK
	end if;
end if;
end process;
end ;
