Library ieee;
Use ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

Entity time_date is
Port 	(	time_sec	:	in	bit;
			hh			:	out	integer range 0 to 31;
			mm			:	out	integer range 0 to 63;
			ss			:	out	integer range 0 to 63
		);
End ;

Architecture time_date_a of time_date is
Begin

Process (time_sec)
Variable cnt	:	integer range 0 to 1 := 0;
Variable ft		:	integer range 0 to 1 := 0;
Variable hh_int	:	integer range 0 to 23;
Variable mm_int	:	integer range 0 to 59;
Variable ss_int	:	integer range 0 to 59;
Begin
if time_sec'event and time_sec = '1' then

	if ft = 0 then
		hh_int := 02;
		mm_int := 30;
		ss_int := 0;
		ft := 1;
	else
		if ss_int = 59 then
			ss_int := 0;
			if mm_int = 59 then
				mm_int := 0;
				if hh_int = 23 then
					hh_int := 0;
				else
					hh_int := hh_int + 1;
				end if;
			else
				mm_int := mm_int + 1;
			end if;
		else
			ss_int := ss_int + 1;
		end if;
	end if;
	hh <= hh_int;
	mm <= mm_int;
	ss <= ss_int;
end if;
End process;
End ;
