// PlotGraph1.cpp: implementation of the PlotGraph class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SeriesPort.h"
#include "PlotGraph1.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
CPen Line(PS_SOLID,1,RGB(0,0,0));
CPen DotLine(PS_DOT,1,RGB(200,200,200));
CPen Plotpen1(PS_SOLID,1,RGB(255,0,0));
CPen Plotpen2(PS_SOLID,1,RGB(0,0,255));
CBrush Brush(RGB(255,255,255));
CWnd *Plot;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

PlotGraph::PlotGraph()
{

}

PlotGraph::~PlotGraph()
{

}

void PlotGraph::Build(CWnd *pWnd)
{
	CClientDC dc(pWnd);
	ScaleX = 0;
	ScaleY = 0;
	XInDlg = 20;
	YInDlg = 30;
	XFnDlg = 720;
	YFnDlg = 440; //480
	XInGh = XInDlg + 30;
	YInGh = YFnDlg - 30;
	XFnGh = XFnDlg - 50;
	YFnGh = YInDlg + 30;
	dc.SelectObject(&Brush);
	dc.Rectangle(XInDlg,YInDlg,XFnDlg,YFnDlg);  //for background
	dc.SelectObject(&Line);
	dc.MoveTo(XInGh,YInGh);			//	Line Vertical Scale
	dc.LineTo(XInGh,YFnGh); 
	dc.MoveTo(XInGh,YInGh);			//	Line Horizaltal Scale
	dc.LineTo(XFnGh,YInGh);
	dc.TextOut(XInGh - 20,YInGh - 10,"0");		//	Y Scale
	dc.TextOut(XInGh - 20,YInGh - 50,"10");
	dc.TextOut(XInGh - 20,YInGh - 90,"20");
	dc.TextOut(XInGh - 20,YInGh - 130,"30");
	dc.TextOut(XInGh - 20,YInGh - 170,"40");
	dc.TextOut(XInGh - 20,YInGh - 210,"50");
	dc.TextOut(XInGh - 20,YInGh - 250,"60");
	dc.TextOut(XInGh - 20,YInGh - 290,"70");
	dc.TextOut(XInGh - 20,YInGh - 330,"80");
	dc.TextOut(XInGh - 20,YInGh - 370,"90");
	dc.TextOut(XInGh - 20,YFnGh - 20,"Temp *C");
	dc.TextOut(XFnGh + 10, YInGh - 10, "Time");
	dc.SelectObject(&DotLine);
	for (int ihor=0; ihor < 8; ihor++)	//9
	{
		ScaleY = ScaleY + 40;
		dc.MoveTo(XInGh,YInGh - ScaleY);		//	Line Horizaltal Dot Scale
		dc.LineTo(XFnGh, YInGh - ScaleY);
	}
	for (int iver = 0; iver < 5; iver++)
	{
		ScaleX = ScaleX + 120;
		dc.MoveTo(XInGh + ScaleX,YInGh);		//	Line Vertical DotScale
		dc.LineTo(XInGh + ScaleX,YFnGh);
	}
}

void PlotGraph::PlotSignal(CWnd *PS)
{
	CClientDC dc(PS);
	if (SelPen == TRUE){dc.SelectObject(&Plotpen1);}
	if (SelPen == FALSE){dc.SelectObject(&Plotpen2);}
	dc.MoveTo(OldPointX,OldPointY);			//	Line Vertical Scale
	dc.LineTo(PointX,PointY); 
}

void PlotGraph::Pointer(int OldX, int OldY, int X, int Y)
{
	OldPointX = OldX;
	OldPointY = OldY;
	PointX = X;
	PointY = Y;
}

void PlotGraph::Scale1(CWnd *SC1)
{
	CClientDC dc(SC1);
	dc.TextOut(XInGh - 5,YInGh + 8,TimeStart);		//	X Scale
	dc.TextOut(XInGh + 95,YInGh + 8,"+15 Sec");
	dc.TextOut(XInGh + 215,YInGh + 8,"+30 Sec");
	dc.TextOut(XInGh + 335,YInGh + 8,"+45 Sec");
	dc.TextOut(XInGh + 455,YInGh + 8,"+60 Sec");
	dc.TextOut(XInGh + 575,YInGh + 8,"+75 Sec");
}

void PlotGraph::Scale2(CWnd *SC2)
{
	CClientDC dc(SC2);
	dc.TextOut(XInGh - 5,YInGh + 8,TimeStart);		//	X Scale
	dc.TextOut(XInGh + 95,YInGh + 8,"+1 Min");
	dc.TextOut(XInGh + 215,YInGh + 8,"+2 Min");
	dc.TextOut(XInGh + 335,YInGh + 8,"+3 Min");
	dc.TextOut(XInGh + 455,YInGh + 8,"+4 Min");
	dc.TextOut(XInGh + 575,YInGh + 8,"+5 Min");
}

void PlotGraph::Scale3(CWnd *SC3)
{
	CClientDC dc(SC3);
	dc.TextOut(XInGh - 5,YInGh + 8,TimeStart);		//	X Scale
	dc.TextOut(XInGh + 95,YInGh + 8,"+4 Min");
	dc.TextOut(XInGh + 215,YInGh + 8,"+8 Min");
	dc.TextOut(XInGh + 335,YInGh + 8,"+12 Min");
	dc.TextOut(XInGh + 455,YInGh + 8,"+16 Min");
	dc.TextOut(XInGh + 575,YInGh + 8,"+20 Min");
}
void PlotGraph::Scale4(CWnd *SC4)
{
	CClientDC dc(SC4);
	dc.TextOut(XInGh - 5,YInGh + 8,TimeStart);		//	X Scale
	dc.TextOut(XInGh + 95,YInGh + 8,"+16 Min");
	dc.TextOut(XInGh + 215,YInGh + 8,"+32 Min");
	dc.TextOut(XInGh + 335,YInGh + 8,"+48 Min");
	dc.TextOut(XInGh + 455,YInGh + 8,"+64 Min");
	dc.TextOut(XInGh + 575,YInGh + 8,"+80 Min");
}

void PlotGraph::Scale5(CWnd *SC5)
{
	CClientDC dc(SC5);
	dc.TextOut(XInGh - 5,YInGh + 8,TimeStart);		//	X Scale
	dc.TextOut(XInGh + 75,YInGh + 8,"+1 Hour 4Min");
	dc.TextOut(XInGh + 195,YInGh + 8,"+2 Hour 8Min");
	dc.TextOut(XInGh + 315,YInGh + 8,"+3 Hour 12Min");
	dc.TextOut(XInGh + 435,YInGh + 8,"+4 Hour 16Min");
	dc.TextOut(XInGh + 555,YInGh + 8,"+5 Hour 20Min");
}

void PlotGraph::Scale6(CWnd *SC6)
{
	CClientDC dc(SC6);
	dc.TextOut(XInGh - 5,YInGh + 8,TimeStart);		//	X Scale
	dc.TextOut(XInGh + 75,YInGh + 8,"+4 Hour 16Min");
	dc.TextOut(XInGh + 195,YInGh + 8,"+8 Hour 32Min");
	dc.TextOut(XInGh + 315,YInGh + 8,"+13 Hour 4Min");
	dc.TextOut(XInGh + 435,YInGh + 8,"+17 Hour 20Min");
	dc.TextOut(XInGh + 555,YInGh + 8,"+21 Hour 36Min");
}
